<template>
	<mobile-frame>
		<view class="info">
			<view class="one">
				<view class="one_1">
					<text>评论商品</text>
				</view>
				<view class="one_2">
					<view class="list" v-for="(item,index) in goodsList" :key="index">
						<view class="list_1">
							<image class="image"
								:src="item.goods.file&&item.goods.file.length>0?item.goods.file[0].url:''" mode="">
							</image>
						</view>
						<view class="list_2">
							<view class="name">
								{{item.goods_name}}
							</view>
							<view class="other_1">
								<text>规格：</text>
								<text>{{item.name}}</text>
							</view>
							<view class="other_1">
								<text>金额：</text>
								<text class="money">¥{{info.type=='0'?item.sell_money:item.group_config.money}}</text>
							</view>
							<view class="other_1">
								<text>数量：</text>
								<text>×{{item.buy_num}}</text>
							</view>

						</view>
					</view>
				</view>
			</view>
			<view class="two">
				<uni-forms ref="form" :modelValue="form" :rules="rules" label-width="auto">
					<uni-forms-item label="评论商品" name="goods">
						<picker class="picker" mode="selector" :range="goodsList" @change="goodsChange"
							range-key="goods_name">
							<view>{{form.goods_name||'请选择评论商品'}}</view>
						</picker>
					</uni-forms-item>
					<uni-forms-item label="评论内容" name="content">
						<uni-easyinput maxlength=-1 type="textarea" v-model="form.content" placeholder="请输入评论内容" />
					</uni-forms-item>
					<uni-forms-item label="上传评论图片" name="file" v-if="readonly==false">
						<upload :list="file" name="file" :count="6" @uplSuc="uplSuc" @uplDel="uplDel"></upload>
					</uni-forms-item>
					<uni-forms-item label="商品评分" name="goods_score">
						<uni-rate :readonly="readonly" size="18" v-model="form.goods_score" />
					</uni-forms-item>
					<uni-forms-item label="发货评分" name="transport_score">
						<uni-rate :readonly="readonly" size="18" v-model="form.transport_score" />
					</uni-forms-item>
					<uni-forms-item label="店铺评分" name="shop_score">
						<uni-rate :readonly="readonly" size="18" v-model="form.shop_score" />
					</uni-forms-item>
				</uni-forms>
				<view class="btn">
					<button type="primary" @click="onSubmit('form')" size="small">提交</button>
				</view>
			</view>
		</view>
	</mobile-frame>
</template>

<script>
	import moment from 'moment';
	import upload from '@/components/upload/index.vue';
	export default {
		components: {
			upload
		},
		data() {
			return {
				id: '',
				// 追加
				rate_id: '',
				user: {},
				form: {},
				info: {},
				file: [],
				// 商品
				goodsList: [],
				rules: {
					content: {
						rules: [{
							required: true,
							errorMessage: '请输入评论内容',
						}]
					},
					grade: {
						rules: [{
							required: true,
							errorMessage: '请输入评论等级',
						}]
					},
					goods: {
						rules: [{
							required: true,
							errorMessage: '请选择评论商品',
						}]
					},
				},
				readonly: false,
			};
		},
		onLoad: function(e) {
			const that = this;
			that.$set(that, `id`, e.id || '');
			// 监听用户是否登录
			that.watchLogin();
		},
		methods: {
			// 监听用户是否登录
			watchLogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: function(res) {
						let user = that.$jwt(res.data);
						if (user) that.$set(that, `user`, user);
						that.search();
					},
					fail: function(err) {
						uni.navigateTo({
							url: `/pages/login/index`
						})
					}
				});
			},
			// 查询列表
			async search() {
				const that = this;
				let user = that.user;
				let res;
				if (that.id) {
					res = await that.$api(`/orderDetail/${that.id}`);
					if (res.errcode == '0') {
						that.$set(that, `info`, res.data.order);
						for (let val of res.data.goods) val.goods_name = val.goods.name
						that.$set(that, `goodsList`, res.data.goods);
						uni.hideLoading();
					}
				}
			},
			async goodsChange(e) {
				const that = this;
				let data = that.goodsList[e.detail.value];
				if (data) that.$set(that, `goodsList`, [data])
				if (data.rate) {
					that.$set(that, `rate_id`, data.rate);
					let res = await that.$api(`/goodsRate/${data.rate}`);
					if (res.errcode == '0') {
						that.$set(that, `form`, res.data);
						that.$set(that.form, `goods_name`, data.goods_name);
						that.$set(that, `readonly`, true)
					}
				} else {
					that.$set(that.form, `goods`, data.goods._id);
					that.$set(that.form, `goods_name`, data.goods_name);
					that.$set(that.form, `goodsSpec`, data._id);
				}
			},
			// 图片上传
			uplSuc(e) {
				const that = this;
				that.$set(that, `${e.name}`, [...that[e.name], e.data]);
			},
			// 图片删除
			uplDel(e) {
				const that = this;
				let data = that[e.name];
				let arr = data.filter((i, index) => index != e.data.index);
				that.$set(that, `${e.name}`, arr)
			},
			// 提交保存
			async onSubmit(ref) {
				const that = this;
				that.$refs[ref].validate().then(async params => {
					if (that.rate_id) {
						let reply = that.form;
						let obj = {
							file: that.file,
							content: params.content,
							time: moment().format('YYYY-MM-DD HH:mm:ss')
						}
						reply.reply.push(obj)
						const arr = await that.$api(`/goodsRate/${that.rate_id}`, 'POST', reply)
						if (arr.errcode == '0') {
							uni.showToast({
								title: `追加成功`,
								icon: 'success',
							});
							uni.navigateBack({
								detail: 1
							})
						} else {
							uni.showToast({
								title: arr.errmsg,
								icon: 'none',
							})
						}
					} else {
						let reply = [{
							file: that.file,
							content: params.content,
							time: moment().format('YYYY-MM-DD HH:mm:ss')
						}];
						params.orderDetail = that.id
						params.reply = reply;
						params.customer = that.user?._id;
						params.shop = that.info?.goods[0]?.shop;
						params.goodsSpec = that.form.goodsSpec;
						const arr = await that.$api(`/goodsRate`, 'POST', params);
						if (arr.errcode == '0') {
							uni.showToast({
								title: `评论成功`,
								icon: 'success',
							});
							uni.navigateBack({
								detail: 1
							})
						} else {
							uni.showToast({
								title: arr.errmsg,
								icon: 'none',
							})
						}
					}
				})
			}
		}
	}
</script>

<style lang="scss">
	.info {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			margin: 2vw;
			border: 1px solid #f1f1f1;
			border-radius: 5px;
			padding: 2vw;

			.one_1 {
				margin: 0 0 2vw 0;

				text {
					font-size: 16px;
					font-weight: bold;
				}
			}

			.one_2 {
				.list {
					display: flex;
					background-color: #f1f1f1;
					padding: 2vw;
					margin: 0 0 2vw 0;
					border-radius: 5px;

					.list_1 {
						width: 22vw;
						height: 22vw;
						border-radius: 5px;

						.image {
							width: 100%;
							height: 100%;
							border-radius: 5px;
						}
					}

					.list_2 {
						width: 63vw;
						padding: 0 0 0 2vw;

						.name {
							font-size: 16px;
							font-weight: bold;
							margin: 0 0 0.5vw 0;
						}

						.other_1 {
							.money {
								color: #ff0000 !important;
							}

							text {
								font-size: 13px;
								color: #858585;
							}

							text:last-child {
								color: #000000;
							}
						}
					}
				}

				.list:last-child {
					margin: 0;
				}
			}
		}

		.two {
			padding: 2vw;

			.picker {
				width: 100%;
				border: 1px solid #3333;
				border-radius: 5px;
				padding: 2vw;
			}

			.uni-input {
				border: #f1f1ff 1px solid;
				padding: 2vw 2vw;
				border-radius: 1vw;
			}

			.btn {
				text-align: center;

				button {
					margin: 0 2vw 2vw 2vw;
					background-color: var(--ff0Color);
					color: var(--fffColor);
				}

				.name {
					color: var(--f85Color);
					font-size: var(--font14Size);
				}
			}
		}
	}

	.uni-forms-item {
		margin-bottom: 6vw !important;
		display: flex;
		flex-direction: row;
	}

	.uni-forms-item__content {
		display: flex;
		align-items: center;
	}
</style>
